(*
 *  beware IRC services, accountmanagecmds.pas
 *  Copyright (C) 2002-2005 Bas Steendijk and peter green
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

unit accountmanagecmds;

interface
  uses
    buser , bstuff , accountUSINGbot ;
  procedure priv_adduser(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
  procedure priv_deluser(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
  procedure priv_userlist(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
  procedure priv_userinfo(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
  procedure priv_moduser(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
  procedure priv_whoami(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
implementation
  {========================================================================user account}
uses
  accountcore , bparse , btime , blinklist , passcryp , bvaliddef , accountmanagecmds_replies , generalreplies;
procedure priv_adduser(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  p:taccount;
  s:string;
  a:integer;
begin
 with botobject do begin
  {if (parc < 3) or (parv[2] = '') then begin
    send(sendtalk+cmd+' <username> <level>');
    exit
  end;}

  s := taccountUSINGserviceunit(srvunit).accountcore.convertaccountname(parv[1]);

  if not validaccountname(s) then begin
    send(sendtalk+reply_invalidusername);
    exit
  end;
  a := strtointdef(parv[2],-1);
  if a < 0 then begin
    send(sendtalk+reply_invalidlevel);
    exit;
  end;
  p := taccountUSINGserviceunit(srvunit).accountcore.findaccount(parv[1]);

  if p <> nil then begin
    send(sendtalk+replacealias(reply_accountalreadyexists,'%account%',parv[1]));
    exit;
  end else begin
    if not taccountUSINGserviceunit(srvunit).accountcore.levelcontrol(haslevel(sptr),a) then begin
      if a > haslevel(sptr) then begin
        send(sendtalk+reply_cantaddwiththislevel);
        exit;
      end;
    end;

    p := taccountUSINGserviceunit(srvunit).accountcore.addaccount(parv[1],a);
    p.lastmailts := unixtime;
    logaction(sptr,cmd+' '+parv[1]+' '+inttostr(a));
  end;
 end;
end;

procedure priv_deluser(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  p:taccount;
begin
 with botobject do begin
  if (parc < 2) or (parv[1] = '') then begin
    send(sendtalk+cmd+' <username>');
    exit
  end;
  p := taccountUSINGserviceunit(srvunit).accountcore.findaccount(parv[1]);
  if p = nil then begin
    send(sendtalk+error_nosuchaccount(parv[1]));
    exit;
  end;

  if not taccountUSINGserviceunit(srvunit).accountcore.levelcontrol(haslevel(sptr),p.level) then begin
    send(sendtalk+reply_cantdeletethislevel);
    exit;
  end;

  logaction(sptr,cmd+' '+p.name);
  linklistdel(tlinklist(taccountUSINGserviceunit(srvunit).accountcore.accountlist),tlinklist(p));
  p.destroy;
 end;
end;

procedure priv_moduser(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  p:taccount;
  s,subcmd:string;
  a:integer;
begin
 with botobject do begin
  {if (parc < 3) or (parv[2] = '') then begin
    send(sendtalk+cmd+' <username> <command> [<param>]');
    send(sendtalk+cmd+' commands: ADDMASK DELMASK NEWPASS LEVEL OPERONLY EMAIL');
    exit
  end;}
  p :=taccountUSINGserviceunit(srvunit). accountcore.findaccount(parv[1]);
  if p = nil then begin
    send(sendtalk+error_nosuchaccount(parv[1]));
    exit;
  end;

  if not taccountUSINGserviceunit(srvunit).accountcore.levelcontrol(haslevel(sptr),p.level) then begin
    send(sendtalk+reply_cantmodifythislevel);
    exit;
  end;

  subcmd := ircupper(parv[2]);
  if subcmd = 'ADDMASK' then begin
    for a := 3 to parc-1 do begin
      s := cookmask(parv[a]);
      if not validmask(s) then begin
        send(sendtalk+reply_invalidmask);
      end else begin
        if p.addmask(s) then begin
          logaction(sptr,cmd+' '+subcmd+' '+p.name+' '+s);
        end else begin
          send(sendtalk+reply_maskalreadyexists);
        end;
      end;
    end;
  end else if subcmd = 'DELMASK' then begin
    for a := 3 to parc-1 do begin
      s := cookmask(parv[a]);
      if p.delmask(s) then begin
        logaction(sptr,cmd+' '+subcmd+' '+p.name+' '+s);
      end else begin
        send(sendtalk+reply_maskdoesnotexist);
      end;
    end;
  end else if pos('PASS',subcmd) <> 0 then begin
    if parv[3] = '' then begin
      logaction(sptr,replacealias(log_accountdisabled,'%account%',p.name ));
      p.password := '';
    end else begin
      logaction(sptr,cmd+' NEWPASS '+p.name);
      if ircupper(parv[4])='PRECRYPT' then begin
        p.password := parv[3];
      end else begin
        p.password := passnewcrypt(parv[3]);
      end;
    end;
  end else if subcmd = 'LEVEL' then begin
    a := strtointdef(parv[3],-1);
    if a >= 0 then begin
      if not taccountUSINGserviceunit(srvunit).accountcore.levelcontrol(haslevel(sptr),a) then begin
        send(sendtalk+reply_cantchangeleveltothis);
        exit;
      end;
      logaction(sptr,cmd+' LEVEL '+p.name+' '+inttostr(p.level)+' -> '+inttostr(a));
      p.level := a;
    end;
  end else if subcmd = 'OPERONLY' then begin
    s := ircupper(parv[3]);
    if ((s = 'ON') or (s = '1')) and (not p.operonly) then begin
      logaction(sptr,cmd+' operonly '+p.name+' ON');
      p.operonly := true
    end else if ((s = 'OFF') or (s = '0')) and (p.operonly) then begin
      logaction(sptr,cmd+' operonly '+p.name+' OFF');
      p.operonly := false ;
    end;
  end else if pos('EMAIL',subcmd) <> 0 then begin

    //logaction(sptr,'Account '+p.name+' email set to '+parv[3]);
    logaction(sptr,replacealias(replacealias(log_emailset,'%account%',p.name),'%email%',parv[3]));
    p.email := parv[3];

  end else begin
    send(sendtalk+'invalid command');
  end;
 end;
end;

procedure priv_userlist(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  p:taccount;
  s:string;
  a,b,minlevel,maxlevel:integer;
begin
 with botobject do begin
  minlevel := -maxlongint;
  maxlevel := maxlongint;
  if (parv[1] <> '') and (parc > 1) then minlevel := strtointdef(parv[1],-maxlongint);
  if (parv[2] <> '') and (parc > 2) then maxlevel := strtointdef(parv[2],maxlongint);

  p := taccountUSINGserviceunit(srvunit).accountcore.accountlist;
  send(sendtalk+reply_userlisttitle);
  a := 0;
  b := 0;
  while p <> nil do begin
    if (p.level >= minlevel) and (p.level <= maxlevel) then begin
      s :=  '    '+p.name+' ';
      while length(s) < 20 do s := s + ' ';
      s := s + inttostr(p.level)+' ';
      while length(s) < 29 do s := s + ' ';
      if p.user <> nil then begin
        s := s + tuser(p.user.p).name;
      end else begin
        s := s + '-';
      end;
      send(sendtalk+s);
      inc(a);
    end;
    inc(b);
    p := taccount(p.next);
  end;
  //send(sendtalk+'--- End of list, '+inttostr(a)+' of '+inttostr(b)+' accounts shown.');
  send(sendtalk+replacealias(replacealias(reply_endofuserlist,'%accountsshown%',inttostr(a)),'%totalaccounts%',inttostr(b)));
  {}
 end;
end;
function agostr(a:integer):string;
begin
  result := inttostr(a div 86400)+' days, '+inttostr((a div 3600) mod 24)+' hours, '+inttostr(a mod 3600)+' seconds';
end;

procedure priv_userinfo(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);


var
  p:taccount;
  s:string;
  sl:tstringlinklist;
  pp:tplinklist;
  a:integer;
begin
 with botobject do begin
  {if (parc < 2) or (parv[2] = '1') then begin
    send(sendtalk+cmd+' <username>');
    exit;
  end;}
  p := taccountUSINGserviceunit(srvunit).accountcore.findaccount(parv[1]);
  if p = nil then begin
    send(sendtalk+error_nosuchaccount(parv[1]));
    exit;
  end;
  //send(sendtalk+'  Name: '#2+p.name+#2'    Level: '#2+inttostr(p.level)+#2);
  send(sendtalk+replacealias(replacealias(reply_userinfonamelevel,'%name%',p.name),'%level%',inttostr(p.level) )  );

  //if p.email <> '' then send(sendtalk+'  email: '#2+p.email+#2);
  //if p.hellouser <> '' then send(sendtalk+'  registered by: '#2+p.hellouser+#2);

  if p.email <> '' then send(sendtalk+replacealias(reply_userinfoemail,'%email%',p.email));
  if p.hellouser <> '' then send(sendtalk+replacealias(reply_userinfohellouser,'%hellouser%',p.hellouser));


  sl := p.mask;
  if sl <> nil then begin
    s := '';
    while (sl <> nil) do begin
      s := s + ' '+sl.s;
      sl := tstringlinklist(sl.next);
      if length(s) > 450 then begin
        send(sendtalk+reply_userinfomasks+s);
        s := '';
      end;
    end;
    if s <> '' then send(sendtalk+reply_userinfomasks+s);

  end else begin
    send(sendtalk+reply_userinfonomasks);
  end;

  if p.user = nil then begin
    send(sendtalk+reply_userinfonotloggedin);
    if p.lastseents <> 0 then begin
      a := unixtime - p.lastseents;
      //send(sendtalk+'  last seen '+agostr(a)+' ago.');
      send(sendtalk+replacealias(reply_userinfolastseen,'%time%',agostr(a)));

    end else if (p.lastmailts <> 0) then begin
      a := unixtime - p.lastmailts;
      //send(sendtalk+'  created: '+agostr(a)+' ago.');
      send(sendtalk+replacealias(reply_userinfocreated,'%time%',agostr(a)));

    end;
  end else begin
    pp := p.user;
    while pp <> nil do begin
      send(sendtalk+reply_userinfologgedin+nickuserhost(tuser(pp.p)));
      pp := tplinklist(pp.next);
    end;
  end;

  if p.operonly then send(sendtalk+reply_userinfomustbeoper);
  if p.password = '' then send(sendtalk+reply_userinfodisabled);

  send(sendtalk+reply_userinfoend);
  {}
 end;
end;

procedure priv_whoami(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  p:taccount;
  s:string;
  sl:tstringlinklist;
  pp:tplinklist;
  a:integer;
begin
 with botobject do begin
  {if (parc < 2) or (parv[2] = '1') then begin
    send(sendtalk+cmd+' <username>');
    exit;
  end;}
  p := taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(sptr); //taccountUSINGserviceunit(srvunit).accountcore.findaccount(parv[1]);
  if p = nil then begin
    send(sendtalk+reply_notloggedin);
    exit;
  end;
  //send(sendtalk+'  Name: '#2+p.name+#2'    Level: '#2+inttostr(p.level)+#2);
  send(sendtalk+replacealias(replacealias(reply_userinfonamelevel,'%name%',p.name),'%level%',inttostr(p.level) )  );

  //if p.email <> '' then send(sendtalk+'  email: '#2+p.email+#2);
  //if p.hellouser <> '' then send(sendtalk+'  registered by: '#2+p.hellouser+#2);

  if p.email <> '' then send(sendtalk+replacealias(reply_userinfoemail,'%email%',p.email));
  if p.hellouser <> '' then send(sendtalk+replacealias(reply_userinfohellouser,'%hellouser%',p.hellouser));


  sl := p.mask;
  if sl <> nil then begin
    s := '';
    while (sl <> nil) do begin
      s := s + ' '+sl.s;
      sl := tstringlinklist(sl.next);
      if length(s) > 450 then begin
        send(sendtalk+reply_userinfomasks+s);
        s := '';
      end;
    end;
    if s <> '' then send(sendtalk+reply_userinfomasks+s);

  end else begin
    send(sendtalk+reply_userinfonomasks);
  end;

  {if p.user = nil then begin
    send(sendtalk+reply_userinfonotloggedin);
    if p.lastseents <> 0 then begin
      a := unixtime - p.lastseents;
      //send(sendtalk+'  last seen '+agostr(a)+' ago.');
      send(sendtalk+replacealias(reply_userinfolastseen,'%time%',agostr(a)));

    end else if (p.lastmailts <> 0) then begin
      a := unixtime - p.lastmailts;
      //send(sendtalk+'  created: '+agostr(a)+' ago.');
      send(sendtalk+replacealias(reply_userinfocreated,'%time%',agostr(a)));

    end;
  end else begin}
  pp := p.user;
  while pp <> nil do begin
    send(sendtalk+reply_userinfologgedin+nickuserhost(tuser(pp.p)));
    pp := tplinklist(pp.next);
  end;


  if p.operonly then send(sendtalk+reply_userinfomustbeoper);
  if p.password = '' then send(sendtalk+reply_userinfodisabled);

  send(sendtalk+reply_userinfoend);
  {}
 end;
end;


end.
