(*
 *  beware IRC services, authipthrottle.pas
 *  Copyright (C) 2002 Bas Steendijk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

{this unit keeps a list of the IP's used for the auth "hello" function and expires them.
this prevents more than one attempt from a single IP within a given time, even after the account itself is gone}

unit authipthrottle;

interface

uses blinklist,authbot,binipstuff;

procedure authipthrottle_add(const ip:tbinip;ts:integer;botobject : tauthbot);
function authipthrottle_find(const ip:tbinip;botobject : tauthbot):integer;
//procedure authipthrottle_del(const ip:tbinip;botobject : tauthbot);
function authipthrottle_del(const ip:tbinip;botobject : tauthbot) : boolean;

procedure timehandler(botobject : tauthbot);
type
  tipthrottle=class(tlinklist)
    ip:tbinip;
    ts:integer;
  end;
var
  ipthrottlelist:tipthrottle;
implementation

uses {authbot,}btime,pgdebugout;





procedure authipthrottle_add(const ip:tbinip;ts:integer;botobject : tauthbot);
var
  p,p2:tipthrottle;
begin
  p2 := nil;
  p := ipthrottlelist;
  while p <> nil do begin
    if comparebinip(p.ip,ip) then begin
      p2 := p;
      break;
    end;
    p := tipthrottle(p.next);
  end;
  if p2 = nil then begin
    p2 := tipthrottle.create;
    linklistadd(tlinklist(ipthrottlelist),tlinklist(p2));
  end;
  p2.ip := ip;
  p2.ts := ts;
end;

function authipthrottle_find(const ip:tbinip;botobject : tauthbot):integer;
var
  p:tipthrottle;
begin
  result := 0;
  p := ipthrottlelist;
  while p <> nil do begin
    if comparebinip(p.ip,ip) then begin
      result := p.ts;
      exit;
    end;
    p := tipthrottle(p.next);
  end;
end;

function authipthrottle_del(const ip:tbinip;botobject : tauthbot) : boolean;
var
  p:tipthrottle;
begin

  p := ipthrottlelist;
  while p <> nil do begin
    if comparebinip(p.ip,ip) then begin
      linklistdel(tlinklist(ipthrottlelist),p);
      p.destroy;
      result := true;
      exit;
    end;
    p := tipthrottle(p.next);
  end;
  result := false;
end;

procedure timehandler;
var
  p,p2:tipthrottle;
  expirets:integer;
begin
  debugout('in authipthrottle.timehandler');
  if unixtime and 31 = 0 then exit;

  if botobject.locopt.registerthrottle <= 0 then exit;

  expirets := unixtime-botobject.locopt.registerthrottle;
  debugout('about to start while loop');
  p := ipthrottlelist;
  while p <> nil do begin
    p2 := tipthrottle(p.next);
    if p.ts < expirets then begin
      linklistdel(tlinklist(ipthrottlelist),p);
      p.destroy;
    end;
    p := p2;
  end;
  debugout('at end of authipthrottle.timehandler');
end;

end.
