(*
 *  beware IRC services, botmanagecommands.pas
 *  Copyright (C) 2002-2005 Bas Steendijk and Peter Green
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)


unit botmanagecommands;

interface
uses
  buser , bstuff , accountUSINGbot ;
procedure priv_level(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_chcomname(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_chinfo(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_chsyntax(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);

//procedure priv_rehash(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_set(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure set_replace(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;var info,syntax:string);
procedure priv_globalset(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure globalset_replace(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;var info,syntax:string);
procedure priv_save(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_saveall(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_restart(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_die(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_diebot(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);

procedure priv_say(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_replyset(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_stop(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_start(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);


implementation
uses
  bparse   , pgstuff      , bsetcommand    , bservunit                 ,
  sysutils , bcmds        , generalreplies , botmanagecommands_replies ,
  bconfig  , replymanager , bconsts        , bservicemngr              ;
procedure priv_level(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a,b:integer;
  s:string;
begin
 with botobject do begin
  if (parc < 2) or (parv[1] = '') then begin
    s := '';
    for a := 0 to botmaxcmd do begin
      s := s + cmdtab[a].cmd+'='+inttostr(cmdtab[a].level)+'    ';
      if length(s) > 50 then begin
        send(sendtalk+s);
        s := '';
      end;
    end;
    if s <> '' then send(sendtalk+s);
    exit
  end;
  parv[1] := ircupper(parv[1]);
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].cmd = parv[1] then begin
      if (parc > 2) and (parv[2] <> '') then
      b := strtointdef(parv[2],-2)
      else b := -2;
      if b > -2 then begin
        logaction(sptr,cmd+' '+cmdtab[a].cmd+' '+inttostr(cmdtab[a].level)+' -> '+inttostr(b));
        cmdtab[a].level := b;
        buildsorted;
      end else begin
        send(sendtalk+cmdtab[a].cmd+'='+inttostr(cmdtab[a].level));
      end;
      exit;
    end;
  end;
  send(sendtalk+'command not found: '+parv[1]);
 end;
end;

procedure priv_chcomname(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a:integer;
begin
 with botobject do begin
  {if (parc < 3) or (parv[2] = '') then begin
    send(sendtalk+cmd+' <old command name> <new command name>');
    exit
  end;}
  parv[1] := ircupper(parv[1]);
  parv[2] := ircupper(parv[2]);

  {check for parv[2] be a valid command (that is, easy to type)}

  if not validcomname(parv[2]) then begin
    send(sendtalk+reply_badcommandname);
    exit
  end;
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].customcmd = parv[2] then begin
      //send(sendtalk+'command '+parv[2]+' already exists, can''t change.');
      send(sendtalk+replacealias(reply_commandalreadyexists,'%command%',parv[2]));

      exit;
    end;
  end;
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].customcmd = parv[1] then begin
      logaction(sptr,cmd+' '+cmdtab[a].customcmd+' '+parv[2]);
      cmdtab[a].customcmd := parv[2];
      buildsorted;
      exit;
    end;
  end;
  send(sendtalk+reply_commandnotfound+' '+parv[1]);
 end;
end;

procedure priv_chinfo(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a:integer;
  s:string;
begin
 with botobject do begin
  s := copy(msg,pos(' ',msg)+1,500);
  s := copy(s,pos(' ',s)+1,500);

  parv[1] := ircupper(parv[1]);
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].customcmd = parv[1] then begin
      logaction(sptr,cmd+' '+cmdtab[a].customcmd+' '+s);
      cmdtab[a].info := s;
      exit;
    end;
  end;
  send(sendtalk+reply_commandnotfound+' '+parv[1]);

 end;
end;

procedure priv_chsyntax(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a:integer;
  s:string;
begin
 with botobject do begin
  s := copy(msg,pos(' ',msg)+1,500);
  s := copy(s,pos(' ',s)+1,500);

  parv[1] := ircupper(parv[1]);
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].customcmd = parv[1] then begin
      logaction(sptr,cmd+' '+cmdtab[a].customcmd+' '+s);
      cmdtab[a].syntax := s;
      exit;
    end;
  end;
  send(sendtalk+reply_commandnotfound+' '+parv[1]);
 end;
end;


procedure priv_set(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  s:string;
begin
 with botobject do begin
  setcommand(sptr,parc,parv,msg,optiontable^,maxoptiontable,sendtalk,cmd,s);
  if s <> '' then logaction(sptr,s);
 end;
end;

procedure set_replace(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;var info,syntax:string);
begin
  with botobject do begin
    setcommand_replace(optiontable^,maxoptiontable,info,syntax);
  end;

end;

procedure priv_globalset(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  s:string;
begin
 with botobject do begin

  setcommand(sptr,parc,parv,msg,bconfig.optiontable,bconfig.maxoptiontable,sendtalk,cmd,s);
  if s <> '' then logaction(sptr,s);
 end;
end;



procedure globalset_replace(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;var info,syntax:string);
begin
  setcommand_replace(bconfig.optiontable,bconfig.maxoptiontable,info,syntax);
end;


procedure priv_save(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
begin
 with botobject do begin
  logaction(sptr,cmd);
  botsave(false);
 end;
end;

procedure priv_saveall(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
begin
 with botobject do begin
  logaction(sptr,cmd);
  saveall;
 end;
end;

{procedure priv_rehash(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
begin
 with botobject do begin
  logaction(sptr,cmd);
  botinit;
  loadaccountdependent;
 end;
end;  }

procedure priv_restart(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
begin
 with botobject do begin
  logaction(sptr,cmd);
  onshutdown(srvunit.tag);
  onstartup(srvunit.tag);
 end;
end;

procedure priv_die(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a:integer;
begin
 with botobject do begin
  logaction(sptr,cmd);

  shutdownreason := '';
  for a := 1 to parc-1 do begin
    if shutdownreason <> '' then shutdownreason := shutdownreason + ' ';
    shutdownreason := shutdownreason+parv[a];
  end;

  {onshutdown;}
  {die does global shutdown atm}
  globalshutdown;
 { halt; -let program run to the end -beware}
 end;
end;

procedure priv_diebot(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a:integer;
begin
 with botobject do begin
  logaction(sptr,cmd);

  shutdownreason := '';
  for a := 1 to parc-1 do begin
    if shutdownreason <> '' then shutdownreason := shutdownreason + ' ';
    shutdownreason := shutdownreason+parv[a];
  end;

  onshutdown(srvunit.tag);
 end;
end;

procedure priv_say(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  s:string;
begin
 with taccountUSINGbot(botobject) do begin

  {if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <message>');
    exit;
  end;}
  s := copy(msg,pos(' ',msg)+1,500);
  s := trimleft(s);
  s := copy(s,pos(' ',s)+1,500);
  logaction(sptr,cmd+' '+parv[1]+' '+s);
  //sendparse(s);
  sendparse(mybot.idstr+' '+tok_privmsg+' '+parv[1]+' :'+s);
 end;
end;

procedure priv_replyset(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  s:string;
begin
 with taccountUSINGbot(botobject) do begin

  {if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <message>');
    exit;
  end;}
  if parv[2] = '' then begin
    s := getreplyescaped(parv[1]);
    if s ='' then begin
      send(sendtalk+reply_nosuchreply);
    end else begin
      send(sendtalk+s);
    end;
  end else begin
    s := copy(msg,pos(' ',msg)+1,500);
    s := trimleft(s);
    s := copy(s,pos(' ',s)+1,500);
    logaction(sptr,cmd+' '+parv[1]+' '+s);
    if setreplyescaped(parv[1],s,-1) then begin
      send(sendtalk+reply_done);

    end else begin
      send(sendtalk+reply_nosuchreply);
    end;
  end;
  //sendparse(s);
  //sendparse(mybot.idstr+' '+tok_privmsg+' '+parv[1]+' :'+s);
 end;
end;

procedure priv_start(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a : integer;
begin
  for a := 0 to maxserviceunit do if serviceunitarray[a] <> nil then
    if uppercase(serviceunitarray[a].name)=uppercase(parv[1]) then
      if @serviceunitarray[a].onstartup  <> nil then
        serviceunitarray[a].onstartup(serviceunitarray[a].tag);
end;

procedure priv_stop(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a : integer;
begin
  for a := 0 to maxserviceunit do if serviceunitarray[a] <> nil then
    if uppercase(serviceunitarray[a].name)=uppercase(parv[1]) then 
      if @serviceunitarray[a].onshutdown  <> nil then
        serviceunitarray[a].onshutdown(serviceunitarray[a].tag);
end;


end.
